"use strict";

{
	const C3 = self.C3;

	C3.Behaviors.Wackytoaster_Flags.Instance = class MyBehaviorInstance extends C3.SDKBehaviorInstanceBase
	{
		constructor(behInst, properties)
		{
			super(behInst);
			
			this._flags = "";
			
			if (properties)
			{
				this._flags = properties[0];
			}
			
			this._SetFlags(this._flags);
			
			// Opt-in to getting calls to Tick()
			//this._StartTicking();
		}

		Release()
		{
			super.Release();
		}

		_SetFlags(n)
		{
			const flagArray = n.split(" ");
			let flagMap = this.GetObjectInstance().GetSavedDataMap();
			
			flagArray.forEach(e => {
				flagMap.set(e, 1);
			});
		}

		_RemoveFlags(n)
		{
			const flagArray = n.split(" ");
			let flagMap = this.GetObjectInstance().GetSavedDataMap();
			
			flagArray.forEach(e => {
				flagMap.delete(e);
			});
		}
		
		_AddFlags(n)
		{
			const flagArray = n.split(" ");
			let flagMap = this.GetObjectInstance().GetSavedDataMap();
			
			flagArray.forEach(e => {
				flagMap.set(e, 1);
			});
		}
		
		SaveToJson()
		{
			return {
				// data to store for savegames
			};
		}

		LoadFromJson(o)
		{
			// load state for savegames
		}
		
		/*
		Tick()
		{
			const dt = this._runtime.GetDt(this._inst);
			const wi = this._inst.GetWorldInfo();
			
			// ... code to run every tick for this behavior ...
		}
		*/

		GetScriptInterfaceClass()
		{
			return self.IMyBehaviorInstance;
		}
	};
	
	// Script interface for behavior instance
	const map = new WeakMap();
	
	self.IMyBehaviorInstance = class IMyBehaviorInstance extends self.IBehaviorInstance {
		constructor()
		{
			super();
			
			// Map by SDK instance
			map.set(this, self.IBehaviorInstance._GetInitInst().GetSdkInstance());
		}
		
		// Example setter/getter property on script interface
		set myProperty(n)
		{
			map.get(this)._SetMyProperty(n);
		}

		get myProperty()
		{
			return map.get(this)._GetMyProperty();
		}
	};
}